ENTITY full_adder IS
	PORT ( a, b, carry_in	    : IN  BIT;
		   sum, carry_out		: OUT BIT
	);
END full_adder;

ARCHITECTURE structural OF full_adder IS
    SIGNAL x1, x2, x3, x4, y1 : BIT;
    COMPONENT and_gate PORT (
        a, b      :   IN  BIT;
        a_and_b   :   OUT BIT
        );
    END COMPONENT and_gate;
    COMPONENT or_gate PORT (
        a, b      :   IN  BIT;
        a_or_b    :   OUT BIT
        );
    END COMPONENT or_gate;
    COMPONENT xor_gate PORT (
        a, b      :   IN  BIT;
        a_xor_b   :   OUT BIT
        );
    END COMPONENT xor_gate;
BEGIN
    and0 : and_gate PORT MAP( a, b, x1 );
    and1 : and_gate PORT MAP( a, carry_in, x2 );
    and2 : and_gate PORT MAP( b, carry_in, x3 );
	or0:   or_gate  PORT MAP( x1, x2, x4 );
	or1:   or_gate  PORT MAP( x3, x4, carry_out );
	xor0:  xor_gate PORT MAP( a, b, y1 );
	xor1:  xor_gate PORT MAP( y1, carry_in, sum );
END structural;

