ENTITY jk IS PORT (
    j, k                 :  IN BIT;
    q                    :  OUT BIT;
    clock, clear, preset :  IN BIT
    );
END jk;

ARCHITECTURE basic OF jk IS
    SIGNAL jkstate : BIT;         -- flip flop state
	SIGNAL jkin    : BIT_VECTOR( 1 DOWNTO 0 );
BEGIN
    jkin(1) <= j;
    jkin(0) <= k;
    q <= jkstate;
    jkupdate: PROCESS( clock, clear, preset ) -- transition function
    BEGIN
        IF clear = '1' THEN
            jkstate <= '0';
        ELSIF preset = '1' THEN
            jkstate <= '1';
        ELSE
            IF( clock'EVENT AND clock = '1' ) THEN
                CASE jkin IS
                    WHEN "00" => jkstate <= jkstate;
                    WHEN "01" => jkstate <= '0';
                    WHEN "10" => jkstate <= '1';
                    WHEN "11" => jkstate <= NOT (jkstate);
                END CASE;
            END IF; -- IF( clock'EVENT AND clock = '1' )
        END IF; -- IF clear = '1'
    END PROCESS jkupdate;
END basic;
